function W = cotWeightMatrix(mesh)
    edges = mesh.E2V;
    weights = zeros(size(edges, 1),1);
    W = sparse(size(mesh.X,1), size(mesh.X,1));

    for i=1:size(edges,1)
        edge = edges(i,:);
        triangles = mesh.E2T(i, 1:2);
        ntriangles = size(mesh.E2T(i, :),2)/2;
        for j=1:ntriangles
            if(triangles(1,j)>0)
               indicesT = mesh.T(triangles(1,j),:);
               c = setdiff(indicesT, edge);
               if(size(c) ~= 1)
                   fprintf('warning: size is wrong\n');
               end
               v1 = mesh.X(edge(1),:);
               v2 = mesh.X(edge(2),:);
               v_mid = mesh.X(c, :);

               vec1 = v1-v_mid;
               vec1 = vec1/norm(vec1);

               vec2 = v2-v_mid;
               vec2 = vec2/norm(vec2);

               alphaij = cot(acos(vec1*vec2'));
               weights(i,1) = weights(i,1) + alphaij;
            end
        end
        W(edge(1), edge(2)) = weights(i)/2;
        W(edge(2), edge(1)) = weights(i)/2;
    end
    
    for i=1:size(W,1)
        W(i,i) = -2.0*sum(W(i,:));
    end 
end